<ngx-loading [show]="loading" />

<div [ngClass]="[jds.mt(30), jds.mb(70), jds.mx(0)]">
  <div [ngClass]="jds.container">
    <div [ngClass]="[jds.d('flex'), jds.mb(25)]">
      <h5>Dashboard Statistik</h5>

      <div [ngClass]="[jds.ms('auto')]">
        <div [ngClass]="[jds.w(270)]">
          <input
            id="daterangepicker"
            [(ngModel)]="daterangepicker"
            [drops]="'down'"
            [opens]="'left'"
            [locale]="locale"
            [showCancel]="true"
            [linkedCalendars]="true"
            [alwaysShowCalendars]="false"
            [showRangeLabelOnInput]="false"
            [keepCalendarOpeningWithRange]="false"
            [closeOnAutoApply]="true"
            [autoApply]="true"
            [maxDate]="maxDate"
            (datesUpdated)="filterTanggal($event)"
            placeholder="Pilih tanggal"
            type="text"
            jdsBiInput
            readonly
            ngxDaterangepickerBootstrap
            aria-describedby="daterangepicker"
          />
        </div>
      </div>
    </div>

    <div [ngClass]="jds.card">
      <div [ngClass]="[jds.cardBody]">
        <div [ngClass]="jds.row">
          <ng-container *ngIf="loadingStatTotal">
            <div
              *ngFor="let item of [0, 1, 2, 4]"
              [ngClass]="jds.col(3)"
            >
              <div class="wrapper-skeleton">
                <ngx-skeleton-loader
                  [theme]="{
                    width: '50%',
                    'border-radius': '0',
                    height: '36px',
                    'margin-bottom': '10px'
                  }"
                />
              </div>
              <div class="wrapper-skeleton">
                <ngx-skeleton-loader
                  [theme]="{
                    width: '60%',
                    'border-radius': '0',
                    height: '22px',
                    'margin-bottom': '0px'
                  }"
                />
              </div>
            </div>
          </ng-container>
          <ng-container *ngIf="!loadingStatTotal">
            <ng-container *ngIf="dataStatTotal.length > 0">
              <div
                [ngClass]="[
                  jds.col(3),
                  jds.d('flex'),
                  jds.justifyContent('center'),
                  jds.borderEnd(1)
                ]"
              >
                <div
                  [ngClass]="[
                    jds.d('flex'),
                    jds.alignItems('center'),
                    jds.pt(20),
                    jds.pb(25)
                  ]"
                >
                  <jds-bi-icon
                    [ngClass]="[jds.me(24)]"
                    [size]="32"
                    name="database"
                  />
                  <div>
                    <h3 [style.fontFamily]="'Roboto'">
                      {{ dataStatTotal[0].count_all }}
                    </h3>
                    <div [ngClass]="[jds.fs(18), jds.fw('bold')]">
                      Total Dataset
                    </div>
                  </div>
                </div>
              </div>
              <div
                [ngClass]="[
                  jds.col(3),
                  jds.d('flex'),
                  jds.alignItems('center'),
                  jds.justifyContent('center')
                ]"
              >
                <div>
                  <h3
                    [style.fontFamily]="'Roboto'"
                    [ngClass]="jds.text('success')"
                  >
                    {{ dataStatTotal[0].count_public }}
                  </h3>
                  <div [ngClass]="[jds.fs(18), jds.fw('bold')]">Publik</div>
                </div>
              </div>
              <div
                [ngClass]="[
                  jds.col(3),
                  jds.d('flex'),
                  jds.alignItems('center'),
                  jds.justifyContent('center')
                ]"
              >
                <div>
                  <h3
                    [style.fontFamily]="'Roboto'"
                    [ngClass]="jds.text('warning')"
                  >
                    {{ dataStatTotal[0].count_internal }}
                  </h3>
                  <div [ngClass]="[jds.fs(18), jds.fw('bold')]">Internal</div>
                </div>
              </div>
              <div
                [ngClass]="[
                  jds.col(3),
                  jds.d('flex'),
                  jds.alignItems('center'),
                  jds.justifyContent('center')
                ]"
              >
                <div>
                  <h3
                    [style.fontFamily]="'Roboto'"
                    [ngClass]="jds.text('danger')"
                  >
                    {{ dataStatTotal[0].count_private }}
                  </h3>
                  <div [ngClass]="[jds.fs(18), jds.fw('bold')]">
                    Dikecualikan
                  </div>
                </div>
              </div>
            </ng-container>
          </ng-container>
        </div>
      </div>
    </div>

    <div [ngClass]="[jds.row, jds.mt(24)]">
      <div [ngClass]="jds.col(6)">
        <div [ngClass]="[jds.card]">
          <div [ngClass]="[jds.cardBody]">
            <h6 [ngClass]="[jds.textAlign('center'), jds.mb(16)]">
              Top 10 Produsen Dataset
            </h6>

            <ng-container *ngIf="loadingTop">
              <div
                class="wrapper-skeleton"
                *ngFor="let number of [50, 70, 40]"
              >
                <ngx-skeleton-loader
                  [theme]="{
                    width: number + '%',
                    'border-radius': '0',
                    height: '22px',
                    'margin-bottom': '10px'
                  }"
                />
              </div>
              <div class="wrapper-skeleton">
                <ngx-skeleton-loader
                  [theme]="{
                    width: '80%',
                    'border-radius': '0',
                    height: '22px',
                    'margin-bottom': '0px'
                  }"
                />
              </div>
            </ng-container>

            <ng-container *ngIf="!loadingTop">
              <ng-container *ngIf="dataTop.length > 0">
                <canvas
                  [datasets]="barChartDataProdusen"
                  [labels]="barChartLabelsAliasProdusen"
                  [options]="barChartOptionsProdusen"
                  [type]="barChartType"
                  baseChart
                  style="width: 100%; height: 460px"
                >
                </canvas>
              </ng-container>
            </ng-container>
          </div>
        </div>
      </div>
      <div [ngClass]="jds.col(6)">
        <div [ngClass]="[jds.card]">
          <div [ngClass]="[jds.cardBody]">
            <h6 [ngClass]="[jds.textAlign('center'), jds.mb(16)]">
              Top 10 Konsumen Dataset
            </h6>

            <ng-container *ngIf="loadingTop">
              <div
                class="wrapper-skeleton"
                *ngFor="let number of [50, 70, 40]"
              >
                <ngx-skeleton-loader
                  [theme]="{
                    width: number + '%',
                    'border-radius': '0',
                    height: '22px',
                    'margin-bottom': '10px'
                  }"
                />
              </div>
              <div class="wrapper-skeleton">
                <ngx-skeleton-loader
                  [theme]="{
                    width: '80%',
                    'border-radius': '0',
                    height: '22px',
                    'margin-bottom': '0px'
                  }"
                />
              </div>
            </ng-container>

            <ng-container *ngIf="!loadingTop">
              <ng-container *ngIf="dataTop.length > 0">
                <canvas
                  [datasets]="barChartDataKonsumen"
                  [labels]="barChartLabelsAliasKonsumen"
                  [options]="barChartOptionsKonsumen"
                  [type]="barChartType"
                  baseChart
                  style="width: 100%; height: 460px"
                >
                </canvas>
              </ng-container>
            </ng-container>
          </div>
        </div>
      </div>
    </div>

    <div [ngClass]="[jds.card, jds.mt(24)]">
      <div [ngClass]="[jds.cardBody]">
        <h6 [ngClass]="[jds.textAlign('center'), jds.mb(16)]">
          Top 10 Dataset
        </h6>
      </div>

      <div [ngClass]="jds.tableResponsive">
        <table
          [ngClass]="[jds.table, jds.borderTop(1)]"
          role="table"
          aria-label="Top 10 Dataset"
          aria-describedby="Table Top 10 Dataset"
        >
          <thead>
            <tr>
              <th scope="col">Judul Dataset</th>
              <th
                class="table-head"
                [style.width.%]="17.5"
                [isSortable]="true"
                [currentSort]="{
                  sort: urutanActive,
                  direction: direktoriActive
                }"
                [colorScheme]="'gray'"
                (filterSort)="filterUrutkan('view')"
                scope="col"
                jdsBiTableHead
                column="view"
              >
                Total Dilihat
              </th>
              <th
                class="table-head"
                [style.width.%]="17.5"
                [isSortable]="true"
                [currentSort]="{
                  sort: urutanActive,
                  direction: direktoriActive
                }"
                [colorScheme]="'gray'"
                (filterSort)="filterUrutkan('access')"
                scope="col"
                jdsBiTableHead
                column="access"
              >
                Total Diunduh
              </th>
            </tr>
          </thead>
          <tbody>
            <ng-container *ngIf="loadingTopDataset">
              <tr *ngFor="let number of [0, 1]">
                <td *ngFor="let number of [0, 1, 2]">
                  <div class="wrapper-skeleton">
                    <ngx-skeleton-loader
                      [theme]="{
                        width: '80%',
                        'border-radius': '0',
                        height: '22px',
                        'margin-bottom': '0px'
                      }"
                    />
                  </div>
                </td>
              </tr>
            </ng-container>

            <ng-container *ngIf="!loadingTopDataset">
              <ng-container *ngIf="dataTopDataset.length > 0">
                <tr *ngFor="let row of dataTopDataset">
                  <td>
                    <a [routerLink]="['/dataset/detail', row.id]">
                      {{ row.name }}
                    </a>
                  </td>
                  <td>
                    <div [ngClass]="[jds.d('flex'), jds.alignItems('center')]">
                      <jds-bi-icon
                        [ngClass]="jds.me(8)"
                        name="eye"
                      />
                      <span>{{ row.count_view_private }}</span>
                    </div>
                  </td>
                  <td>
                    <div [ngClass]="[jds.d('flex'), jds.alignItems('center')]">
                      <jds-bi-icon
                        [ngClass]="jds.me(8)"
                        name="circle-down"
                      />
                      <span>{{ row.count_access_private }}</span>
                    </div>
                  </td>
                </tr>
              </ng-container>
            </ng-container>
          </tbody>
        </table>
      </div>
    </div>
  </div>
</div>
